Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/ThresholdAscentPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/ThresholdAscentPolicy.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/ThresholdAscentPolicy.cs	(revision 11742)
@@ -0,0 +1,133 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.Bandits.BanditPolicies {
+  /* see: Streeter and Smith: A simple distribution-free approach to the max k-armed bandit problem, Proceedings  of the 12th
+ International Conference, CP 2006, Nantes, France, September 25-29, 2006. pp 560-574 */
+
+  public class ThresholdAscentPolicy : IBanditPolicy {
+    public const int numBins = 101;
+    public const double binSize = 1.0 / (numBins - 1);
+
+    private class ThresholdAscentActionInfo : IBanditPolicyActionInfo {
+
+      // for each arm store the number of observed rewards for each bin of size delta
+      // for delta = 0.01 we have 101 bins
+      // the first bin is freq of rewards  >= 0 // all
+      // the second bin is freq of rewards > 0
+      // the third bin is freq of rewards > 0.01
+      // the last bin is for rewards > 0.99
+      // 
+      // (also see RewardBin function)
+      public int[] rewardHistogram = new int[numBins];    // for performance reasons we store cumulative counts (freq of rewards > lower threshold)
+      public int Tries { get; private set; }
+      public int thresholdBin = 1;
+      public double Value { get { return rewardHistogram[thresholdBin] / (double)Tries; } }
+
+      public bool Disabled { get { return Tries == -1; } }
+
+      public void UpdateReward(double reward) {
+        Tries++;
+        for (var idx = thresholdBin; idx <= RewardBin(reward); idx++)
+          rewardHistogram[idx]++;
+      }
+
+      public void Disable() {
+        Tries = -1;
+      }
+
+      public void Reset() {
+        Tries = 0;
+        thresholdBin = 1;
+        Array.Clear(rewardHistogram, 0, rewardHistogram.Length);
+      }
+
+      public void PrintStats() {
+        if (Tries >= 0) {
+          Console.Write("{0,6}", Tries);
+        } else {
+          Console.Write("{0,6}", "");
+        }
+      }
+
+      // maps a reward value to it's bin
+      private static int RewardBin(double reward) {
+        Debug.Assert(reward >= 0 && reward <= 1.0);
+        // reward = 0 => 0
+        // ]0.00 .. 0.01] => 1
+        // ]0.01 .. 0.02] => 2
+        // ...
+        // ]0.99 .. 1.00] => 100
+        if (reward <= 0) return 0;
+        return (int)Math.Ceiling((reward / binSize));
+      }
+    }
+
+    private readonly int s;
+    private readonly double delta;
+
+    public ThresholdAscentPolicy(int s = 100, double delta = 0.05) {
+      this.s = s;
+      this.delta = delta;
+    }
+
+    private double U(double mu, int totalTries, int n, int k) {
+      //var alpha = Math.Log(2.0 * totalTries * k / delta);
+      double alpha = Math.Log(2) + Math.Log(totalTries) + Math.Log(k) - Math.Log(delta);
+      return mu + (alpha + Math.Sqrt(2 * n * mu * alpha + alpha * alpha)) / n;
+    }
+
+
+    public int SelectAction(Random random, IEnumerable<IBanditPolicyActionInfo> actionInfos) {
+      Debug.Assert(actionInfos.Any());
+      var myActionInfos = actionInfos.OfType<ThresholdAscentActionInfo>();
+      UpdateThreshold(myActionInfos);
+
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
+      int k = myActionInfos.Count(a => !a.Disabled);
+      var totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+      int aIdx = -1;
+      foreach (var aInfo in myActionInfos) {
+        aIdx++;
+        if (aInfo.Disabled) continue;
+        if (aInfo.Tries == 0) return aIdx;
+        double mu = aInfo.Value; // probability of rewards > T 
+        double q = U(mu, totalTries, aInfo.Tries, k);          // totalTries is max iterations in original paper
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = aIdx;
+        }
+      }
+      Debug.Assert(bestAction > -1);
+      return bestAction;
+    }
+
+
+    private void UpdateThreshold(IEnumerable<ThresholdAscentActionInfo> actionInfos) {
+      var thresholdBin = 1; // first bin to check is bin idx 1 == freq of rewards > 0
+      while (thresholdBin < (numBins - 1) && actionInfos.Sum(a => a.rewardHistogram[thresholdBin]) >= s) {
+        thresholdBin++;
+        // Console.WriteLine("New threshold {0:F2}", T);
+      }
+      foreach (var aInfo in actionInfos) {
+        aInfo.thresholdBin = thresholdBin;
+      }
+    }
+
+
+    public IBanditPolicyActionInfo CreateActionInfo() {
+      return new ThresholdAscentActionInfo();
+    }
+
+    public override string ToString() {
+      return string.Format("ThresholdAscentPolicy({0},{1:F2})", s, delta);
+    }
+
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCB1Policy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCB1Policy.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCB1Policy.cs	(revision 11742)
@@ -0,0 +1,37 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits.BanditPolicies {
+  // policy for k-armed bandit (see Auer et al. 2002)
+  public class UCB1Policy : IBanditPolicy {
+    public int SelectAction(Random random, IEnumerable<IBanditPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<DefaultPolicyActionInfo>().ToArray(); // TODO: performance
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+
+      for (int a = 0; a < myActionInfos.Length; a++) {
+        if (myActionInfos[a].Disabled) continue;
+        if (myActionInfos[a].Tries == 0) return a;
+        var q = myActionInfos[a].SumReward / myActionInfos[a].Tries + Math.Sqrt((2 * Math.Log(totalTries)) / myActionInfos[a].Tries);
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = a;
+        }
+      }
+      Debug.Assert(bestAction > -1);
+      return bestAction;
+    }
+
+    public IBanditPolicyActionInfo CreateActionInfo() {
+      return new DefaultPolicyActionInfo();
+    }
+    public override string ToString() {
+      return "UCB1Policy";
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCB1TunedPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCB1TunedPolicy.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCB1TunedPolicy.cs	(revision 11742)
@@ -0,0 +1,51 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits.BanditPolicies {
+  // policy for k-armed bandit (see Auer et al. 2002)
+  public class UCB1TunedPolicy : IBanditPolicy {
+
+    public int SelectAction(Random random, IEnumerable<IBanditPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<MeanAndVariancePolicyActionInfo>();
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+
+      int aIdx = -1;
+      foreach (var aInfo in myActionInfos) {
+        aIdx++;
+        if (aInfo.Disabled) continue;
+        if (aInfo.Tries == 0) return aIdx;
+
+        var sumReward = aInfo.SumReward;
+        var tries = aInfo.Tries;
+
+        var avgReward = sumReward / tries;
+        var q = avgReward + Math.Sqrt((Math.Log(totalTries) / tries) * Math.Min(1.0 / 4, V(aInfo, totalTries))); // 1/4 is upper bound of bernoulli distributed variable
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = aIdx;
+        }
+      }
+      Debug.Assert(bestAction > -1);
+      return bestAction;
+    }
+
+    public IBanditPolicyActionInfo CreateActionInfo() {
+      return new MeanAndVariancePolicyActionInfo();
+    }
+
+    private double V(MeanAndVariancePolicyActionInfo actionInfo, int totalTries) {
+      var s = actionInfo.Tries;
+      return actionInfo.RewardVariance + Math.Sqrt(2 * Math.Log(totalTries) / s);
+    }
+
+    public override string ToString() {
+      return "UCB1TunedPolicy";
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCBNormalPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCBNormalPolicy.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCBNormalPolicy.cs	(revision 11742)
@@ -0,0 +1,44 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits.BanditPolicies {
+  public class UCBNormalPolicy : IBanditPolicy {
+
+    public int SelectAction(Random random, IEnumerable<IBanditPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<MeanAndVariancePolicyActionInfo>();
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+      int aIdx = -1;
+      foreach (var aInfo in myActionInfos) {
+        aIdx++;
+        if (aInfo.Disabled) continue;
+        if (totalTries <= 1 || aInfo.Tries <= 1 || aInfo.Tries <= Math.Ceiling(8 * Math.Log(totalTries))) return aIdx;
+
+        var tries = aInfo.Tries;
+        var avgReward = aInfo.AvgReward;
+        var rewardVariance = aInfo.RewardVariance;
+        var estVariance = 16.0 * rewardVariance * (Math.Log(totalTries - 1) / tries);
+        var q = avgReward + Math.Sqrt(estVariance);
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = aIdx;
+        }
+      }
+      Debug.Assert(bestAction > -1);
+      return bestAction;
+    }
+
+    public IBanditPolicyActionInfo CreateActionInfo() {
+      return new MeanAndVariancePolicyActionInfo();
+    }
+
+    public override string ToString() {
+      return "UCBNormalPolicy";
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCTPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCTPolicy.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/BanditPolicies/UCTPolicy.cs	(revision 11742)
@@ -0,0 +1,46 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+namespace HeuristicLab.Algorithms.Bandits.BanditPolicies {
+  /* Kocsis et al. Bandit based Monte-Carlo Planning */
+  public class UCTPolicy : IBanditPolicy {
+    private readonly double c;
+
+    public UCTPolicy(double c = 1.0) {
+      this.c = c;
+    }
+
+
+    public int SelectAction(Random random, IEnumerable<IBanditPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<DefaultPolicyActionInfo>();
+      int bestAction = -1;
+      double bestQ = double.NegativeInfinity;
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+
+      int aIdx = -1;
+      foreach (var aInfo in myActionInfos) {
+        aIdx++;
+        if (aInfo.Disabled) continue;
+        if (aInfo.Tries == 0) return aIdx;
+        var q = aInfo.SumReward / aInfo.Tries + 2.0 * c * Math.Sqrt(Math.Log(totalTries) / aInfo.Tries);
+        if (q > bestQ) {
+          bestQ = q;
+          bestAction = aIdx;
+        }
+      }
+      Debug.Assert(bestAction > -1);
+      return bestAction;
+    }
+
+    public IBanditPolicyActionInfo CreateActionInfo() {
+      return new DefaultPolicyActionInfo();
+    }
+
+    public override string ToString() {
+      return string.Format("UCTPolicy({0:F2})", c);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/GrammarPolicies/RandomNoResamplingPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/GrammarPolicies/RandomNoResamplingPolicy.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/GrammarPolicies/RandomNoResamplingPolicy.cs	(revision 11742)
@@ -0,0 +1,44 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.GrammaticalOptimization;
+
+namespace HeuristicLab.Algorithms.Bandits.GrammarPolicies {
+  public class RandomNoResamplingPolicy : IGrammarPolicy {
+
+    private readonly Dictionary<ReadonlySequence, bool> done;
+    private readonly Dictionary<Tuple<ReadonlySequence, ReadonlySequence>, ReadonlySequence> nextState;
+
+
+    public RandomNoResamplingPolicy() {
+      this.done = new Dictionary<ReadonlySequence, bool>();
+    }
+
+    public ReadonlySequence SelectAction(Random random, ReadonlySequence state, IEnumerable<ReadonlySequence> actions) {
+      var allDone = true;
+      foreach (var a in actions) {
+        var p = Tuple.Create(state, a);
+        allDone &= nextState.ContainsKey(p) && Done(nextState[p]);
+        if (!allDone) break;
+      }
+      if(allDone)
+      return actions
+        .Where(a => !nextState.ContainsKey(Tuple.Create(state, a)) || Done(nextState[Tuple.Create(state, a)]))
+        .SelectRandom(random);
+    }
+
+    public void UpdateReward(ReadonlySequence state, ReadonlySequence action, double reward, ReadonlySequence newState) {
+      var key = Tuple.Create(state, action);
+      nextState[key] = newState;
+      if (newState.IsTerminal) done[newState] = true;
+      if 
+    }
+
+    public bool Done(ReadonlySequence state) {
+      return done.ContainsKey(state);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/GrammarPolicies/RandomPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/GrammarPolicies/RandomPolicy.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/GrammarPolicies/RandomPolicy.cs	(revision 11742)
@@ -0,0 +1,23 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Common;
+using HeuristicLab.Problems.GrammaticalOptimization;
+
+namespace HeuristicLab.Algorithms.Bandits.GrammarPolicies {
+  public class RandomPolicy : IGrammarPolicy {
+    public ReadonlySequence SelectAction(Random random, ReadonlySequence state, IEnumerable<ReadonlySequence> actions) {
+      return actions.SelectRandom(random);
+    }
+
+    public void UpdateReward(ReadonlySequence state, ReadonlySequence action, double reward, ReadonlySequence newState) {
+      // ignore
+    }
+
+    public bool Done(ReadonlySequence state) {
+      return false;
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/HeuristicLab.Algorithms.Bandits.csproj	(revision 11742)
@@ -44,4 +44,20 @@
   <ItemGroup>
     <Compile Include="BanditHelper.cs" />
+    <Compile Include="BanditPolicies\BernoulliPolicyActionInfo.cs" />
+    <Compile Include="BanditPolicies\BernoulliThompsonSamplingPolicy.cs" />
+    <Compile Include="BanditPolicies\BoltzmannExplorationPolicy.cs" />
+    <Compile Include="BanditPolicies\ChernoffIntervalEstimationPolicy.cs" />
+    <Compile Include="BanditPolicies\DefaultPolicyActionInfo.cs" />
+    <Compile Include="BanditPolicies\EpsGreedyPolicy.cs" />
+    <Compile Include="BanditPolicies\GaussianThompsonSamplingPolicy.cs" />
+    <Compile Include="BanditPolicies\GenericThompsonSamplingPolicy.cs" />
+    <Compile Include="BanditPolicies\MeanAndVariancePolicyActionInfo.cs" />
+    <Compile Include="BanditPolicies\ModelPolicyActionInfo.cs" />
+    <Compile Include="BanditPolicies\RandomPolicy.cs" />
+    <Compile Include="BanditPolicies\ThresholdAscentPolicy.cs" />
+    <Compile Include="BanditPolicies\UCB1Policy.cs" />
+    <Compile Include="BanditPolicies\UCB1TunedPolicy.cs" />
+    <Compile Include="BanditPolicies\UCBNormalPolicy.cs" />
+    <Compile Include="BanditPolicies\UCTPolicy.cs" />
     <Compile Include="Bandits\BernoulliBandit.cs" />
     <Compile Include="Bandits\GaussianBandit.cs" />
@@ -49,44 +65,12 @@
     <Compile Include="Bandits\IBandit.cs" />
     <Compile Include="Bandits\TruncatedNormalBandit.cs" />
+    <Compile Include="GrammarPolicies\RandomPolicy.cs" />
+    <Compile Include="IPolicy.cs" />
+    <Compile Include="IBanditPolicy.cs" />
+    <Compile Include="IBanditPolicyActionInfo.cs" />
     <Compile Include="OnlineMeanAndVarianceEstimator.cs" />
-    <Compile Include="IPolicyActionInfo.cs" />
     <Compile Include="Models\BernoulliModel.cs" />
     <Compile Include="Models\GaussianModel.cs" />
     <Compile Include="Models\IModel.cs" />
-    <Compile Include="Policies\BernoulliThompsonSamplingPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Policies\BoltzmannExplorationPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Policies\ChernoffIntervalEstimationPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Policies\BernoulliPolicyActionInfo.cs" />
-    <Compile Include="Policies\ModelPolicyActionInfo.cs" />
-    <Compile Include="Policies\EpsGreedyPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Policies\GaussianThompsonSamplingPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Policies\GenericThompsonSamplingPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Policies\MeanAndVariancePolicyActionInfo.cs" />
-    <Compile Include="Policies\DefaultPolicyActionInfo.cs" />
-    <Compile Include="Policies\EmptyPolicyActionInfo.cs" />
-    <Compile Include="Policies\RandomPolicy.cs" />
-    <Compile Include="Policies\UCB1Policy.cs" />
-    <Compile Include="IPolicy.cs" />
-    <Compile Include="Policies\UCB1TunedPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Policies\UCBNormalPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Policies\UCTPolicy.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
@@ -95,4 +79,8 @@
       <Project>{3A2FBBCB-F9DF-4970-87F3-F13337D941AD}</Project>
       <Name>HeuristicLab.Common</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.GrammaticalOptimization\HeuristicLab.Problems.GrammaticalOptimization.csproj">
+      <Project>{cb9dccf6-667e-4a13-b82d-dbd6b45a045e}</Project>
+      <Name>HeuristicLab.Problems.GrammaticalOptimization</Name>
     </ProjectReference>
   </ItemGroup>
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IBanditPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IBanditPolicy.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IBanditPolicy.cs	(revision 11742)
@@ -0,0 +1,13 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  // this interface represents a policy for bandit problems
+  public interface IBanditPolicy {
+    int SelectAction(Random random, IEnumerable<IBanditPolicyActionInfo> actions);
+    IBanditPolicyActionInfo CreateActionInfo();
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IBanditPolicyActionInfo.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IBanditPolicyActionInfo.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/IBanditPolicyActionInfo.cs	(revision 11742)
@@ -0,0 +1,18 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.Bandits {
+  public interface IBanditPolicyActionInfo {
+    bool Disabled { get; }
+    double Value { get; }
+    int Tries { get; }
+    void UpdateReward(double reward);
+    void Disable();
+    // reset causes the state of the action to be reinitialized (as after constructor-call)
+    void Reset();
+    void PrintStats();
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/BernoulliModel.cs	(revision 11742)
@@ -9,4 +9,5 @@
 namespace HeuristicLab.Algorithms.Bandits.Models {
   public class BernoulliModel : IModel {
+
     private int success;
     private int failure;
@@ -47,4 +48,8 @@
       return new BernoulliModel() { failure = this.failure, success = this.success };
     }
+
+    public override string ToString() {
+      return string.Format("Bernoulli with Beta prior: mu={0:F2}", (success + alpha) / (success + alpha + failure + beta));
+    }
   }
 }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Models/GaussianModel.cs	(revision 11742)
@@ -7,4 +7,5 @@
   // 2) unknown mean and unknown variance
   public class GaussianModel : IModel {
+
     private OnlineMeanAndVarianceEstimator estimator = new OnlineMeanAndVarianceEstimator();
 
@@ -82,8 +83,8 @@
       }
 
+
       // sample from the posterior marginal for mu (expected value) equ. 91
       // p(µ|D) = T2αn (µ| µn, βn/(αnκn)) 
 
-      // sample from Tk distribution : http://stats.stackexchange.com/a/70270
       var t2alpha = alglib.invstudenttdistribution((int)(2 * posteriorAlpha), random.NextDouble());
 
@@ -91,6 +92,14 @@
       return theta;
 
-      //return alglib.invnormaldistribution(random.NextDouble()) * + theta;
-      //return alglib.invstudenttdistribution((int)(2 * posteriorAlpha), 0.99) * (posteriorBeta*posteriorK + posteriorBeta) / (posteriorAlpha*posteriorK) + posteriorMean;
+
+      /*
+       * value function : 0.99-quantile
+      // sample posterior mean and posterior variance independently
+      var sampledPrec = Rand.GammaRand(random, posteriorAlpha) * posteriorBeta;
+      var t2alpha = alglib.invstudenttdistribution((int)(2 * posteriorAlpha), random.NextDouble());
+      var sampledMean = t2alpha * posteriorBeta / (posteriorAlpha * posteriorK) + posteriorMean;
+
+      return alglib.invnormaldistribution(0.99) / Math.Sqrt(sampledPrec) + sampledMean;
+       */
     }
 
@@ -114,4 +123,27 @@
         return new GaussianModel(meanPriorMu, meanPriorVariance, precisionPriorAlpha, precisionPriorBeta);
     }
+
+    public override string ToString() {
+      if (knownVariance) {
+        var posteriorMeanVariance = 1.0 / (estimator.N / rewardVariance + 1.0 / meanPriorVariance);
+        var posteriorMeanMean = posteriorMeanVariance * (meanPriorMu / meanPriorVariance + estimator.Sum / rewardVariance);
+        return string.Format("Gaussian(mu, var=0.1), mu ~ Gaussian(mu'={0:F3}, var'={1:F3})", posteriorMeanMean, posteriorMeanVariance);
+      } else {
+        var posteriorMean = (priorK * meanPriorMu + estimator.Sum) / (priorK + estimator.N);
+        var posteriorK = priorK + estimator.N;
+        var posteriorAlpha = precisionPriorAlpha + estimator.N / 2.0;
+        double posteriorBeta;
+        if (estimator.N > 0) {
+          posteriorBeta = precisionPriorBeta + 0.5 * estimator.N * estimator.Variance + priorK * estimator.N * Math.Pow(estimator.Avg - meanPriorMu, 2) / (2.0 * (priorK + estimator.N));
+        } else {
+          posteriorBeta = precisionPriorBeta;
+        }
+        var nu = (int)(2 * posteriorAlpha);
+        var meanVariance = posteriorBeta / (posteriorAlpha * posteriorK) * (nu / (double)(nu - 2));
+        return string.Format("Gaussian(mu, var), mu ~ T{0}(mu'={1:F3}, var'={2:F3}), 1.0/var ~ Gamma(mu={3:F3}, var={4:F3})",
+          nu, posteriorMean, meanVariance,
+          posteriorAlpha / posteriorBeta, posteriorAlpha / (posteriorBeta * posteriorBeta));
+      }
+    }
   }
 }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs	(revision 11742)
@@ -17,7 +17,7 @@
     private readonly Random random;
     private readonly int contextLen;
-    private readonly IPolicy policy;
+    private readonly IBanditPolicy policy;
 
-    public AlternativesContextSampler(IProblem problem, Random random, int maxLen, int contextLen, IPolicy policy) {
+    public AlternativesContextSampler(IProblem problem, Random random, int maxLen, int contextLen, IBanditPolicy policy) {
       this.maxLen = maxLen;
       this.problem = problem;
@@ -45,9 +45,9 @@
 
 
-    private Dictionary<string, IPolicyActionInfo[]> contextActionInfos;
+    private Dictionary<string, IBanditPolicyActionInfo[]> contextActionInfos;
     private List<Tuple<string, int>> updateChain;
 
     private void InitPolicies(IGrammar grammar) {
-      this.contextActionInfos = new Dictionary<string, IPolicyActionInfo[]>();
+      this.contextActionInfos = new Dictionary<string, IBanditPolicyActionInfo[]>();
       this.updateChain = new List<Tuple<string, int>>();
     }
@@ -82,5 +82,5 @@
           var endIdx = Math.Min(startIdx + contextLen, ntIdx);
           var lft = phrase.Subsequence(startIdx, endIdx - startIdx + 1).ToString();
-          lft = problem.Hash(lft);
+          lft = problem.CanonicalRepresentation(lft);
           if (!contextActionInfos.ContainsKey(lft)) {
             contextActionInfos.Add(lft, g.GetAlternatives(nt).Select(_ => policy.CreateActionInfo()).ToArray());
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs	(revision 11742)
@@ -16,7 +16,7 @@
     private readonly Random random;
     private readonly IProblem problem;
-    private readonly IPolicy policy;
+    private readonly IBanditPolicy policy;
 
-    public AlternativesSampler(IProblem problem, IPolicy policy, int maxLen) {
+    public AlternativesSampler(IProblem problem, IBanditPolicy policy, int maxLen) {
       this.problem = problem;
       this.maxLen = maxLen;
@@ -43,9 +43,9 @@
 
 
-    private Dictionary<char, IPolicyActionInfo[]> ntActionInfos;
+    private Dictionary<char, IBanditPolicyActionInfo[]> ntActionInfos;
     private List<Tuple<char, int>> updateChain;
 
     private void InitPolicies(IGrammar grammar) {
-      this.ntActionInfos = new Dictionary<char, IPolicyActionInfo[]>();
+      this.ntActionInfos = new Dictionary<char, IBanditPolicyActionInfo[]>();
       this.updateChain = new List<Tuple<char, int>>();
       foreach (var nt in grammar.NonTerminalSymbols) {
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization.csproj
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization.csproj	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization.csproj	(revision 11742)
@@ -46,4 +46,7 @@
     <Compile Include="AlternativesContextSampler.cs" />
     <Compile Include="ExhaustiveRandomFirstSearch.cs" />
+    <Compile Include="MctsContextualSampler.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="MctsSampler.cs" />
     <Compile Include="ExhaustiveDepthFirstSearch.cs" />
